import bpy
from .utils import get_addon_prefs
class VIEW3D_MT_nd_primitive_menu(bpy.types.Menu):
    bl_idname = "VIEW3D_MT_nd_primitive_menu"
    bl_label = "ND Primitives"

    @classmethod
    def poll(cls, context):
        if context.mode == 'OBJECT':
            return True

    def draw(self, context):
        draw_items(self, context)

def menu_func(self, context):
    layout = self.layout
    layout.menu(VIEW3D_MT_nd_primitive_menu.bl_idname, icon="FILE_3D")
    layout.separator()

def register_add_menu():
    prefs = get_addon_prefs()

    if prefs.show_in_menu == "ADD_MESH":
        bpy.types.VIEW3D_MT_mesh_add.prepend(draw_add_none_destructive_primitive)

    elif prefs.show_in_menu == "OWN_CATEGORY_IN_ADD_MENU":
        bpy.types.VIEW3D_MT_mesh_add.prepend(menu_func)
        
    elif prefs.show_in_menu == "OWN_MENU_CATEGORY":
        bpy.types.VIEW3D_MT_add.prepend(draw_add_none_destructive_primitive)

    elif prefs.show_in_menu == "NONE":
        pass

def update_add_menu(self, context):
    unregister_add_menu()

    if self.show_in_menu == "ADD_MESH":
        bpy.types.VIEW3D_MT_mesh_add.prepend(draw_add_none_destructive_primitive)

    elif self.show_in_menu == "OWN_CATEGORY_IN_ADD_MENU":
        bpy.types.VIEW3D_MT_mesh_add.prepend(menu_func)
        
    elif self.show_in_menu == "OWN_MENU_CATEGORY":
        bpy.types.VIEW3D_MT_add.prepend(menu_func)

    elif self.show_in_menu == "NONE":
        unregister_add_menu()

def unregister_add_menu():
    bpy.types.VIEW3D_MT_mesh_add.remove(draw_add_none_destructive_primitive)
    bpy.types.VIEW3D_MT_mesh_add.remove(menu_func)
    bpy.types.VIEW3D_MT_add.remove(menu_func)

def draw_items(self, context):
    if context.mode == 'OBJECT':
        layout = self.layout    
        layout.label(text="None-Destructive", icon='FILE_3D')
        layout.operator("mesh.add_none_destructive_primitive", text="Grid", icon='MESH_PLANE').type = 'Grid'
        layout.operator("mesh.add_none_destructive_primitive", text="Cube", icon='MESH_CUBE').type = 'Cube'
        layout.operator("mesh.add_none_destructive_primitive", text="Circle", icon='MESH_CIRCLE').type = 'Circle'
        layout.operator("mesh.add_none_destructive_primitive", text="UV Sphere", icon='MESH_UVSPHERE').type = 'UV Sphere'
        layout.operator("mesh.add_none_destructive_primitive", text="Ico Sphere", icon='MESH_ICOSPHERE').type = 'Ico Sphere'
        layout.operator("mesh.add_none_destructive_primitive", text="Cylinder", icon='MESH_CYLINDER').type = 'Cylinder'
        layout.operator("mesh.add_none_destructive_primitive", text="Cone", icon='MESH_CONE').type = 'Cone'
        layout.operator("mesh.add_none_destructive_primitive", text="Torus", icon='MESH_TORUS').type = 'Torus'
        layout.operator("mesh.add_none_destructive_primitive", text="Quad Sphere", icon='SPHERE').type = 'Quad Sphere'
        layout.operator("mesh.add_none_destructive_primitive", text="Capsule", icon='MESH_CAPSULE').type = 'Capsule'
        layout.operator("mesh.add_none_destructive_primitive", text="Mod Cylinder", icon='MOD_SCREW').type = 'Mod Cylinder'
        layout.operator("mesh.add_none_destructive_primitive", text="Spiral", icon='MOD_SCREW').type = 'Spiral'

def draw_add_none_destructive_primitive(self, context):
    draw_items(self, context)
    layout = self.layout    
    layout.separator()
